﻿<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:output method="text" encoding="UTF-8"/>
	<xsl:template match="/">
		<xsl:if test="//KJE135/PROPERTY_VALUE='AIS'">
({
	"<xsl:value-of select="generate-id()"/>": {
		"tableName": "DESCRIPT",
		"fields" : {
			"ORGANIZATION_CODE": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//ORGANIZATION_CODE"/></xsl:call-template>},
			"VENDOR_NAME": { "type": "MEMO", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//VENDOR/VENDOR_NAME"/></xsl:call-template>},
			"VENDOR_CODE": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//VENDOR/@code"/></xsl:call-template>},
			"VENDOR_URL": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//VENDOR/@Url"/></xsl:call-template>},
			"PRODUCT_NO": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//PRODUCT_NO"/></xsl:call-template>},
			"VERSION_NO": { "type": "LONG", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//VERSION_NO"/></xsl:call-template>},
			"LANG": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//LANG"/></xsl:call-template>},
			"CONTACT_ID": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//Contact.Group/@Id"/></xsl:call-template>},
			"CONTACT_LANG": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//Contact.Group/@Lang"/></xsl:call-template>},
			"CONTACT_NAME": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//Contact.Group/@Name"/></xsl:call-template>},
			"CONTACT_TYPE": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//Contact.Group/@Type"/></xsl:call-template>},
			"CONTACT_LABEL": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//Contact.Group/@Label"/></xsl:call-template>},
			"CONTACT_ADDRESS": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//Contact.Group/@Adress"/></xsl:call-template>},
			"SYSTEM_ORGANIZATION": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//SYSTEM_ORGANIZATION"/></xsl:call-template>},
			"SYSTEM_VERSION_NO": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//SYSTEM_VERSION_NO"/></xsl:call-template>}
		}
	}<xsl:apply-templates select="//KJA001" />
})
		</xsl:if>
	</xsl:template>
	<!-- ************************************************ROOT***************************************************** -->
<xsl:template match="KJA001">
	,
	"<xsl:value-of select="generate-id()"/>": {
		"tableName": "BASIC",
		"fields": {
			"SHEET_GP_ID": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE134/PROPERTY_VALUE"/></xsl:call-template>},
			"SHEET_TYPE": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE135/PROPERTY_VALUE"/></xsl:call-template>},
			"SHEET_NUMBER": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE098/PROPERTY_VALUE"/></xsl:call-template>},
			"USE_FORMAT": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE136/PROPERTY_VALUE"/></xsl:call-template>},
			"SUBMITTED_DATE": { "type": "DATETIME", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE137/PROPERTY_VALUE"/></xsl:call-template>},
			"CREATION_DATE": { "type": "DATETIME", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE016/PROPERTY_VALUE"/></xsl:call-template>},
			"REVISED_DATE": { "type": "DATETIME", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE017/PROPERTY_VALUE"/></xsl:call-template>},
			"REVISION_HISTORY": { "type": "LONG", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE014/PROPERTY_VALUE"/></xsl:call-template>},
			"P_ORGANIZATION_ID": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE138/PROPERTY_VALUE"/></xsl:call-template>},
			"P_ENTERPRISE_ID": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE011/PROPERTY_VALUE"/></xsl:call-template>},
			"P_ORGANIZATION_ADD_ID": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE139/PROPERTY_VALUE"/></xsl:call-template>},
			"P_ENTERPRISE_ADD_ID": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE140/PROPERTY_VALUE"/></xsl:call-template>},
			"P_JAMP_PARTY_ID": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE141/PROPERTY_VALUE"/></xsl:call-template>},
			"P_CORPORATE_NAME_C": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE012/PROPERTY_VALUE"/></xsl:call-template>},
			"P_CORPORATE_NAME_L": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE297/PROPERTY_VALUE"/></xsl:call-template>},
			"P_REMARKS": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE142/PROPERTY_VALUE"/></xsl:call-template>},
			"C_SECTION_NAME": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE143/PROPERTY_VALUE"/></xsl:call-template>},
			"C_SECTION_ADDRESS": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE144/PROPERTY_VALUE"/></xsl:call-template>},
			"C_SECTION_PHONE_NO": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE145/PROPERTY_VALUE"/></xsl:call-template>},
			"C_SECTION_FAX_NO": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE146/PROPERTY_VALUE"/></xsl:call-template>},
			"C_SECTION_MAIL": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE147/PROPERTY_VALUE"/></xsl:call-template>},
			"S_SECTION_NAME": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE093/PROPERTY_VALUE"/></xsl:call-template>},
			"S_PHONE_NO": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE124/PROPERTY_VALUE"/></xsl:call-template>},
			"R_ORGANIZATION_ID": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE149/PROPERTY_VALUE"/></xsl:call-template>},
			"R_ENTERPRISE_ID": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE150/PROPERTY_VALUE"/></xsl:call-template>},
			"R_ORGANIZATION_ADD_ID": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE151/PROPERTY_VALUE"/></xsl:call-template>},
			"R_ENTERPRISE_ADD_ID": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE152/PROPERTY_VALUE"/></xsl:call-template>},
			"R_JAMP_PARTY_ID": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE153/PROPERTY_VALUE"/></xsl:call-template>},
			"R_CORPORATE_NAME": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE078/PROPERTY_VALUE"/></xsl:call-template>},
			"R_SECTION": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE154/PROPERTY_VALUE"/></xsl:call-template>},
			"R_ADDRESS": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE155/PROPERTY_VALUE"/></xsl:call-template>},
			"R_CONTACT_NAME": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE090/PROPERTY_VALUE"/></xsl:call-template>},
			"R_PHONE_NO": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE156/PROPERTY_VALUE"/></xsl:call-template>},
			"R_FAX_NO": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE157/PROPERTY_VALUE"/></xsl:call-template>},
			"R_SECTION_MAIL": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE091/PROPERTY_VALUE"/></xsl:call-template>},
			"R_REMARKS_1": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE158/PROPERTY_VALUE"/></xsl:call-template>},
			"R_REMARKS_2": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE159/PROPERTY_VALUE"/></xsl:call-template>},
			"R_REMARKS_3": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE160/PROPERTY_VALUE"/></xsl:call-template>},
			"R_PRODUCT_ID": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE079/PROPERTY_VALUE"/></xsl:call-template>},
			"P_PRODUCT_ID": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE164/PROPERTY_VALUE"/></xsl:call-template>},
			"MANUFACTURER": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE101/PROPERTY_VALUE"/></xsl:call-template>},
			"P_PRODUCT_ID_C": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE018/PROPERTY_VALUE"/></xsl:call-template>},
			"P_PRODUCT_ID_L": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE298/PROPERTY_VALUE"/></xsl:call-template>},
			"P_PRODUCT_NAME": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE019/PROPERTY_VALUE"/></xsl:call-template>},
			"P_GENERAL_NAME": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE172/PROPERTY_VALUE"/></xsl:call-template>},
			"P_SERIES_NAME": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE173/PROPERTY_VALUE"/></xsl:call-template>},
			"P_PRODUCT_REMARKS": { "type": "MEMO", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE174/PROPERTY_VALUE"/></xsl:call-template>},
			"P_ADDITION_REMARKS": { "type": "MEMO", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE183/PROPERTY_VALUE"/></xsl:call-template>},
			"MAKING_TO_SET": { "type": "LONG", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE176/PROPERTY_VALUE"/></xsl:call-template>},
			"REPORTED_UNIT": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE177/PROPERTY_VALUE"/></xsl:call-template>},
			"MASS_OF_PRODUCT": { "type": "DOUBLE", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE023/PROPERTY_VALUE"/></xsl:call-template>},
			"MASS_UNIT": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="concat(//KJE023/PROPERTY_VALUE/@prefix, //KJE023/PROPERTY_VALUE/@unit)"/></xsl:call-template>},
			"GADSL_DIVISION": { "type": "YESNO", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE178/PROPERTY_VALUE"/></xsl:call-template>},
			"JIG_DIVISION": { "type": "YESNO", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE179/PROPERTY_VALUE"/></xsl:call-template>},
			"CONTENT_DIVISION": { "type": "YESNO", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE180/PROPERTY_VALUE"/></xsl:call-template>},
			"MATERIAL_LIST": { "type": "DOUBLE", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE181/PROPERTY_VALUE"/></xsl:call-template>},
			"SUBSTANCE_LIST": { "type": "DOUBLE", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="//KJE182/PROPERTY_VALUE"/></xsl:call-template>}
		}
	}
	<xsl:for-each select="//KJA022">
		<xsl:apply-templates select="self::node()[concat(.//KJE079/PROPERTY_VALUE, .//KJE164/PROPERTY_VALUE)!='']" />
	</xsl:for-each>
	<xsl:apply-templates select="//KJA027" />
	</xsl:template>
	
	<!-- ************************************************型番情報部***************************************************** -->
	<xsl:template match="KJA022">
	,
	"<xsl:value-of select="generate-id()"/>": {
		"tableName": "PRODUCT_ID",
		"fields": {
			"REQUESTER": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select=".//KJE079/PROPERTY_VALUE"/></xsl:call-template>},
			"PUBLISHER": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select=".//KJE164/PROPERTY_VALUE"/></xsl:call-template>}
		}
	}
	</xsl:template>
	
	<!-- ************************************************階層部***************************************************** -->
	<xsl:template match="KJA027">
	,
	"<xsl:value-of select="generate-id()"/>": {
		"tableName": "LAYER",
		"fields": {
			"NAME": { "type": "MEMO", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select=".//KJE055/PROPERTY_VALUE"/></xsl:call-template>},
			"QUANTITY": { "type": "DOUBLE", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select=".//KJE057/PROPERTY_VALUE"/></xsl:call-template>},
			"LV": { "type": "LONG", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select=".//KJE184/PROPERTY_VALUE"/></xsl:call-template>}
		}
	}<xsl:apply-templates select=".//KJA028[count(.//KJE059)!=0]" />
	</xsl:template>
	
	<!-- ************************************************部品部***************************************************** -->
	<xsl:template match="KJA028">
	,
	"<xsl:value-of select="generate-id()"/>": {
		"tableName": "PART",
		"fields": {
			"NAME": { "type": "MEMO", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select=".//KJE059/PROPERTY_VALUE"/></xsl:call-template>},
			"QUANTITY": { "type": "DOUBLE", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select=".//KJE185/PROPERTY_VALUE"/></xsl:call-template>},
			"LV": { "type": "LONG", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select=".//KJE186/PROPERTY_VALUE"/></xsl:call-template>}
		}
	}<xsl:apply-templates select=".//KJA029[count(.//KJE187)!=0]" />
	</xsl:template>
	
	<!-- ************************************************材料部***************************************************** -->
	<xsl:template match="KJA029">
	,
	"<xsl:value-of select="generate-id()"/>": {
		"tableName": "MATERIAL",
		"fields": {
			"MAT_USE": { "type": "LONG", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="number(substring(.//KJE187/PROPERTY_VALUE, 1, 2))"/></xsl:call-template>},
			"CLASS_CODE": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select=".//KJE189/PROPERTY_VALUE"/></xsl:call-template>},
			"STANDARD": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select=".//KJE190/PROPERTY_VALUE"/></xsl:call-template>},
			"MASS": { "type": "DOUBLE", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select=".//KJE128/PROPERTY_VALUE"/></xsl:call-template>},
			"MASS_UNIT": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="concat(.//KJE128/PROPERTY_VALUE/@prefix, .//KJE128/PROPERTY_VALUE/@unit)"/></xsl:call-template>},
			"REMARKS": { "type": "MEMO", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select=".//KJE296/PROPERTY_VALUE"/></xsl:call-template>}
		}
	}<xsl:apply-templates select=".//KJA030[count(.//KJE070)!=0]" />
	</xsl:template>
	
	<!-- ************************************************物質部***************************************************** -->
	<xsl:template match="KJA030">
		<xsl:variable name="ver" select="substring(//PROPERTY_SNAME[.='Use format']/following-sibling::node(), 5, 1)"/>
	,
	"<xsl:value-of select="generate-id()"/>": {
		"tableName": "SUBSTANCE",
		"fields": {
			"NAME": { "type": "MEMO", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select=".//KJE070/PROPERTY_VALUE"/></xsl:call-template>},
			"CAS": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select=".//KJE071/PROPERTY_VALUE"/></xsl:call-template>},
			"RATE": { "type": "DOUBLE", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select=".//KJE131/PROPERTY_VALUE"/></xsl:call-template>},
			"RATE_UNIT": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select=".//KJE131/PROPERTY_VALUE/@unit"/></xsl:call-template>},
			"MASS": { "type": "DOUBLE", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select=".//KJE133/PROPERTY_VALUE"/></xsl:call-template>},
			"MASS_UNIT": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="concat(.//KJE133/PROPERTY_VALUE/@prefix, .//KJE133/PROPERTY_VALUE/@unit)"/></xsl:call-template>},
			"REMARKS": { "type": "MEMO", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select=".//KJE191/PROPERTY_VALUE"/></xsl:call-template>}
		}
	}
		<xsl:if test="$ver='3'"><xsl:apply-templates select=".//KJA031[count(.//KJE194)!=0]" /></xsl:if>
		<xsl:if test="$ver='4'"><xsl:apply-templates select=".//KJA031[count(.//KJE278)!=0]" /></xsl:if>
	</xsl:template>
	
	<!-- ************************************************法令部***************************************************** -->
	<xsl:template match="KJA031">
	,
	"<xsl:value-of select="generate-id()"/>": {
		"tableName": "CORRESPOND",
		"fields": {
			"LAW_ID": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select=".//KJE192/PROPERTY_VALUE"/></xsl:call-template>},
			"CODE": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select="concat(.//KJE194/PROPERTY_VALUE, .//KJE278/PROPERTY_VALUE)"/></xsl:call-template>},
			"REMARKS": { "type": "TEXT", "value": <xsl:call-template name="escape"><xsl:with-param name="s" select=".//KJE195/PROPERTY_VALUE"/></xsl:call-template>}
		}
	} 
	</xsl:template>

  <!-- ************************************************ function escape ***************************************************** -->
  <!-- Main template for escaping strings; used by above template and for object-properties 
       Responsibilities: placed quotes around string, and chain up to next filter, escape-bs-string -->
	<xsl:template name="escape">
		<xsl:param name="s"/>
		<xsl:text>"</xsl:text>
		<xsl:call-template name="escape-bs-string">
			<xsl:with-param name="s" select="$s"/>
		</xsl:call-template>
		<xsl:text>"</xsl:text>
	</xsl:template>
  
  <!-- Escape the backslash (\) before everything else. -->
	<xsl:template name="escape-bs-string">
		<xsl:param name="s"/>
		<xsl:choose>
			<xsl:when test="contains($s,'\')">
				<xsl:call-template name="escape-quot-string">
					<xsl:with-param name="s" select="concat(substring-before($s,'\'),'\\')"/>
				</xsl:call-template>
				<xsl:call-template name="escape-bs-string">
					<xsl:with-param name="s" select="substring-after($s,'\')"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="escape-quot-string">
					<xsl:with-param name="s" select="$s"/>
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
  
  <!-- Escape the double quote ("). -->
  <xsl:template name="escape-quot-string">
	<xsl:param name="s"/>
	<xsl:choose>
	  <xsl:when test="contains($s,'&quot;')">
		<xsl:call-template name="encode-string">
		  <xsl:with-param name="s" select="concat(substring-before($s,'&quot;'),'\&quot;')"/>
		</xsl:call-template>
		<xsl:call-template name="escape-quot-string">
		  <xsl:with-param name="s" select="substring-after($s,'&quot;')"/>
		</xsl:call-template>
	  </xsl:when>
	  <xsl:otherwise>
		<xsl:call-template name="encode-string">
		  <xsl:with-param name="s" select="$s"/>
		</xsl:call-template>
	  </xsl:otherwise>
	</xsl:choose>
  </xsl:template>
  
  <!-- Replace tab, line feed and/or carriage return by its matching escape code. Can't escape backslash
	   or double quote here, because they don't replace characters (&#x0; becomes \t), but they prefix 
	   characters (\ becomes \\). Besides, backslash should be seperate anyway, because it should be 
	   processed first. This function can't do that. -->
  <xsl:template name="encode-string">
	<xsl:param name="s"/>
	<xsl:choose>
	  <!-- tab -->
	  <xsl:when test="contains($s,'&#x9;')">
		<xsl:call-template name="encode-string">
		  <xsl:with-param name="s" select="concat(substring-before($s,'&#x9;'),'\t',substring-after($s,'&#x9;'))"/>
		</xsl:call-template>
	  </xsl:when>
	  <!-- line feed -->
	  <xsl:when test="contains($s,'&#xA;')">
		<xsl:call-template name="encode-string">
		  <xsl:with-param name="s" select="concat(substring-before($s,'&#xA;'),'\n',substring-after($s,'&#xA;'))"/>
		</xsl:call-template>
	  </xsl:when>
	  <!-- carriage return -->
	  <xsl:when test="contains($s,'&#xD;')">
		<xsl:call-template name="encode-string">
		  <xsl:with-param name="s" select="concat(substring-before($s,'&#xD;'),'\r',substring-after($s,'&#xD;'))"/>
		</xsl:call-template>
	  </xsl:when>
	  <xsl:otherwise><xsl:value-of select="$s"/></xsl:otherwise>
	</xsl:choose>
  </xsl:template>
  
</xsl:stylesheet>