﻿/*********************************************************************************************************************************
    機能：コレクションをファイルパス配列に変換
注意事項：obj : コレクション
*********************************************************************************************************************************/
function getInsertFiles(obj, isDrop){
	var files = [];
	var e = new Enumerator(obj);
	for (; !e.atEnd(); e.moveNext()){
		if (isDrop) {
			if (FSO.GetExtensionName(e.item()).toUpperCase()=="XML") { files[files.length] = e.item(); }
		}else{
			if (FSO.GetExtensionName(e.item().Path).toUpperCase()=="XML") { files[files.length] = e.item().Path; }
		}
	}
	if (files.length==0) {
		return false;
	}else{
		return files;
	}
}

/*********************************************************************************************************************************
    機能：データ入力
注意事項：files : 配列
*********************************************************************************************************************************/
function insertData(files){
	if (setting.chkAlertMinI!=""){
		if ( files.length >= setting.chkAlertMinI ){
			if ( !confirm("対象のファイルが "+ files.length +"件 あります。\nかなり時間がかかりますが登録しますか？") ){ return false; }
		}
	}
	$("#hdOutput").attr("disabled", "disabled").children().css("filter","gray");	//Excel出力の無効化
	err = [];　//エラーオブジェクトをクリア
	var res = JetMDB.getRsArr("SELECT MAX(ID) FROM V_SEARCH_SAUCE");
	if (res.length==1){
		var beforeMax = 0;
	}else{
		var beforeMax = res[1][0]-0;
	}
	$("#result").html('<div style="width:60%; margin:0 auto; padding-top:100px;"><div id="progressBar"></div><div id="fileName" style="font-size:15px; color:#ddd; position:relative; top:-20px; left:20px"></div></div>');
	$("#progressBar").progressbar({max: files.length-1, width: "60%"});
	for (var i=0; i<files.length; i++){
		(function(){
			var in_i = i;
			setTimeout(function(){
				var percent = vbFormatPercent((in_i+1) / files.length);
				$("#fileName").text( percent +"　:　"+ FSO.GetFileName(files[in_i]) );
				$("#progressBar").progressbar("option", "value", in_i);
				insertMain (files, beforeMax, in_i);
			}, 250 * i);
		})();
	}
}
/*********************************************************************************************************************************
    機能：データ入力実処理
注意事項：
*********************************************************************************************************************************/
function insertMain (files, beforeMax, i){
	var afterMax = beforeMax;
	//SQL登録
	var sql = getAIS_SQL(files[i]);
	JetMDB.clearSQL();
	for (var j=0; j<sql.length; j++){
		JetMDB.setSQL(sql[j]);
	}
	//実行処理
	var res = JetMDB.Execute();
	if (typeof res == ""){		//sqlでエラー発生の場合
		err[err.length] = "file: "+ FSO.GetFileName(files[i]) +"\nErrString: "+ res;
	}else if (sql.join("")==""){	//ファイルがXML書式に適合していなかった場合
		err[err.length] = "file: "+ FSO.GetFileName(files[i]) +"\nErrString: AIS書式のXMLではありません";
	}else{
		//ファイルコピー
		var res = JetMDB.getRsArr("SELECT FORMAT(MAX(ID),'00000') FROM V_SEARCH_SAUCE");
		afterMax = res[1][0];
		FSO.CopyFile(files[i], basePath +"files\\"+ afterMax +".xml");
		//削除フラグ確認
		if (setting.chkDeleteFile) {
			FSO.DeleteFile(files[i], true); 
		}
	}
	//最終ファイルだったら終了処理
	if (i==files.length-1) {
		//表の再描画
		lastCriteria = ['登録完了ファイル']
		createResultTable(
			"SELECT "+
				"FORMAT(ID,'00000') AS ID,"+
				"初版,改訂,製造者名,[製品番号(英)],一般名称,"+
				"IIF(GADSL,'●','') AS GADSL,"+
				"IIF(JIG,'●','') AS JIG,"+
				"IIF(含有,'●','') AS 含有,"+
				"書式,FORMAT(物質リスト,'0.000') AS 物質リスト "+
			"FROM V_SEARCH_SAUCE "+
			"WHERE ID BETWEEN "+ (beforeMax-0+1) +" AND 99999"
		, true);
		//エラー表示終了処理
		if (err.length!=0){
			alert(err.length+"件のエラーが発生しました\n\n" + err.join("\n\n"));
		}
	}
}

/*********************************************************************************************************************************
    機能：AISオブジェクト取得関数
注意事項：無し
*********************************************************************************************************************************/
function getAIS_SQL (path) {
	//オブジェクト化
	var oSQL = eval( getTransform(path, "dic/getSQLfromAIS.xsl").convert(strHalf + strWebsafe, ["”"]) );
	var sql = [];
	for (var id in oSQL) {
		//変数に値を代入
		var fldName = "", val = "";
		for (var fld in oSQL[id]["fields"]) {
			oSQL[id]["fields"][fld].value = $.trim(oSQL[id]["fields"][fld].value);
			if ( oSQL[id]["fields"][fld].value != "" ){
				//fldName取得
				fldName += ", " + fld;
				val += ", ";
				switch (oSQL[id]["fields"][fld].type) {
				case "LONG":
				case "DOUBLE": val += oSQL[id]["fields"][fld].value; break;
				case "YESNO": val += Boolean(oSQL[id]["fields"][fld].value - 0); break;
				case "MEMO":
				case "TEXT": val += "'" + oSQL[id]["fields"][fld].value.replace(/'/g, "''").replace(/''''/g, "''") + "'"; break;
				case "DATETIME":
					if ( vbIsDate(oSQL[id]["fields"][fld].value) ){
						val += "#" + oSQL[id]["fields"][fld].value + "#";
					} else {
						val += "NULL";
					}
					break;
				}
			}
		}
		//取得した内容をSQLに差込
		switch (oSQL[id]["tableName"]) {
		case "DESCRIPT":
							sql[sql.length] = "INSERT INTO TBL_DESCRIPT(INSERT_DATE" + fldName + ") VALUES( NOW()" + val + ");";
							sql[sql.length] = "INSERT INTO TBL_USERADD (LINK, COL1, COL2, COL3, COL4, COL5) SELECT MAX(ID), '', '', '', '', '' FROM TBL_DESCRIPT;"; break;
		case "BASIC":		sql[sql.length] = "INSERT INTO TBL_BASIC(LINK" + fldName + ") SELECT MAX(ID)" + val + " FROM TBL_DESCRIPT;"; break;
		case "LAYER":		sql[sql.length] = "INSERT INTO TBL_LAYER(LINK" + fldName + ") SELECT MAX(ID)" + val + " FROM TBL_BASIC;" ;break;
		case "PART":		sql[sql.length] = "INSERT INTO TBL_PART(LINK" + fldName + ") SELECT MAX(ID)" + val + " FROM TBL_LAYER;" ;break;
		case "MATERIAL":	sql[sql.length] = "INSERT INTO TBL_MATERIAL(LINK" + fldName + ") SELECT MAX(ID)" + val + " FROM TBL_PART;" ;break;
		case "SUBSTANCE":	sql[sql.length] = "INSERT INTO TBL_SUBSTANCE(LINK" + fldName + ") SELECT MAX(ID)" + val + " FROM TBL_MATERIAL;" ;break;
		case "CORRESPOND":	sql[sql.length] = "INSERT INTO TBL_CORRESPOND(LINK" + fldName + ") SELECT MAX(ID)" + val + " FROM TBL_SUBSTANCE;" ;break;
		case "PRODUCT_ID":
			if (val!=", NULL, NULL"){
				sql[sql.length] = "INSERT INTO TBL_PRODUCT_ID(LINK" + fldName + ") SELECT MAX(ID)" + val + " FROM TBL_DESCRIPT;" ;
			}
			break;
		}
	}
	return sql;
}