﻿/*********************************************************************************************************************************
    機能：検索SQL作成
注意事項：無し
*********************************************************************************************************************************/
function getSearchSQL(){
	lastCriteria = [];
	
	//検索条件オブジェクト取得
	var criteria = {};
	$('#criteria input:checkbox[checked="checked"]').each(function(){
		var parent = this.id.replace(/^chk/,"");
		var val = {};
		var reg = new RegExp(parent);
		$(this).siblings("input, select").each(function(){
			if ($(this).attr("type")=="radio"){
				if ($(this).attr("checked")=="checked"){
					val["type"] = "boole"
					val[this.name.replace(reg,"Value")] = $(this).val();
				}
			}else if ( $(this).is(".dtp") ){
				val["type"] = "date";
				val[this.id.replace(reg,"Value")] = $(this).val();
			}else{
				val["type"] = "text";
				val[this.id.replace(reg,"Value")] = $(this).val();
			}
		});
		if ( /^chkUser/.test(this.id) ) {
			criteria[$(this).next().attr("val")] = val;
		}else{
			criteria[$(this).next().text()] = val;
		}
	});
	
	//SQL作成
	var sql = ["SELECT"];
	sql[sql.length] = "FORMAT(ID,'00000') AS ID";
	sql[sql.length] = ",初版,改訂,製造者名,[製品番号(英)],一般名称";
	sql[sql.length] = ",IIF(GADSL,'●','') AS GADSL";
	sql[sql.length] = ",IIF(JIG,'●','') AS JIG";
	sql[sql.length] = ",IIF(含有,'●','') AS 含有";
	sql[sql.length] = ",書式";
	sql[sql.length] = ",FORMAT(物質リスト,'0.000') AS 物質リスト";
	for (var o in setting.colView){
		if ( setting.colView[o] ) {
			sql[sql.length] = colSQL[o];
		}
	}
	sql[sql.length] = "FROM V_SEARCH_SAUCE";
	sql[sql.length] = "WHERE ID>0";
	for (var o in criteria){
		switch (criteria[o].type){
		case "boole":
			if (criteria[o].ctValue=="equal"){
				sql[sql.length] = "AND tgt_"+ o;
				lastCriteria.push("["+ o +"]を含む");
			}else{
				sql[sql.length] = "AND tgt_"+ o +" =FALSE";
				lastCriteria.push("["+ o +"]を含まない");
			}
			break;
		case "date":
			if ( criteria[o].ctValueStart == "" || criteria[o].ctValueEnd == "" ){ return {"err": true, "value":"日付に空欄があります"}; }
			if ( !vbIsDate(criteria[o].ctValueStart) || !vbIsDate(criteria[o].ctValueEnd) ){ return {"err": true, "value":"日付として認識できません"}; }
			sql[sql.length] = "AND ("+ o +" BETWEEN #"+ criteria[o].ctValueStart +"# AND #"+ criteria[o].ctValueEnd +"#)";
			lastCriteria.push("["+ o +"]"+ criteria[o].ctValueStart +"から"+　criteria[o].ctValueEnd);
			break;
		case "text":
			var header = o;
			if (header.match(/\(/ig)){
				var header = "["+ o +"]"
			}
			//検索条件文字列の別名判定
			var chkAlias = o;
			if ( /^追記/.test(chkAlias) && setting.alias[chkAlias.slice(-1)-1]!="") {
				chkAlias = setting.alias[chkAlias.slice(-1)-1];
			}
			//文字列の検索条件判定
			if (criteria[o].ctValueOpt=="equal") {
				sql[sql.length] = "AND "+ header +" = '"+ criteria[o].ctValue.replace(/'/g, "''") +"'";
				lastCriteria.push("["+ chkAlias +"]が '"+ criteria[o].ctValue +"' と等しい");
			}else if (criteria[o].ctValueOpt=="notequal"){
				sql[sql.length] = "AND "+ header +" <> '"+ criteria[o].ctValue.replace(/'/g, "''") +"'";
				lastCriteria.push("["+ chkAlias +"]が '"+ criteria[o].ctValue +"' と等しくない");
			}else{
				//検索条件文字列別取り
				var viewCriteria = criteria[o].ctValue;
				criteria[o].ctValue = criteria[o].ctValue.replace(/([\_\%\*\[\]])/g, "[$1]").replace(/'/g, "''");	//文字列のエスケープ
				switch (criteria[o].ctValueOpt){
				case "like":
					sql[sql.length] = "AND "+ header +" LIKE '%"+ criteria[o].ctValue +"%'";
					lastCriteria.push("["+ chkAlias +"]が '"+ viewCriteria +"' を含む");
					break;
				case "notlike":
					sql[sql.length] = "AND ("+ header +" LIKE '%"+ criteria[o].ctValue +"%') = FALSE";
					lastCriteria.push("["+ chkAlias +"]が '"+ viewCriteria +"' を含まない");
					break;
				case "left":
					sql[sql.length] = "AND "+ header +" LIKE '"+ criteria[o].ctValue +"%'";
					lastCriteria.push("["+ chkAlias +"]が '"+ viewCriteria +"' で始まる");
					break;
				case "right":
					sql[sql.length] = "AND "+ header +" LIKE '%"+ criteria[o].ctValue +"'";
					lastCriteria.push("["+ chkAlias +"]が '"+ viewCriteria +"' で終わる");
					break;
				}
			}
		}
	}
	return {"err": false, "value":sql.join("\n")};
}

/*********************************************************************************************************************************
    機能：AIS検索リスト表示
注意事項：無し
*********************************************************************************************************************************/
function createResultTable(sql, nonAlert){
	//結果の取得
	var res = JetMDB.getRsArr(sql);
	if (setting.chkAlertMinS!="" && nonAlert==undefined){
		if ( (res.length-1) >= setting.chkAlertMinS){
			if (!confirm("検索結果が "+ (res.length-1) +"件 あります。表示しますか？")) { return false; }
		}
	}
	
	//画面表示
	$("#result").html('<div class="loading">検索中...</div>');
	//出力ボタンの有効判定
	if (res.length==1 || xlMaxRow==0){
		$("#hdOutput").attr("disabled", "disabled").children().css("filter","gray");
	}else{
		$("#hdOutput").removeAttr("disabled").children().css("filter","none");
	}
	setTimeout(function(){timeout(res)},0);
	
	var timeout = function (res){
		//最終検索SQL保管
		lastSearchSQL = sql;
		//テーブルの作成
		var t = ['<table>'];
		t[t.length]="<caption>検索結果 ： "+ (res.length-1) +"件<br/>検索条件 ： "+ lastCriteria.join("　|　") +"</caption>";
		t[t.length]="<thead>";
		for (var i=0,lenR=res.length; i<lenR; i++){
			t[t.length]="<tr>";
			for (var j=0,lenC=res[i].length; j<lenC; j++){
				if (i==0){
					if ( /物質$/.test(res[i][j]) ){
						t[t.length]='<th style="width:80px;"><span>'+ res[i][j] + "</span></th>";
					}else if ( /^追記/.test(res[i][j]) && setting.alias[ res[i][j].slice(-1)-1 ]!="" ) {
						t[t.length]='<th class="col'+ (j+1) +'"><span>'+ setting.alias[ res[i][j].slice(-1)-1 ] + "</span></th>";
					}else{
						t[t.length]='<th class="col'+ (j+1) +'"><span>'+ res[i][j] + "</span></th>";
					}
				}else{
					switch (j){
					case 0: case 1: case 2: case 6:
					case 7: case 8: case 9: case 10:
						t[t.length]='<td class="col'+ (j+1) +'"><div>'+ res[i][j] + '</div></td>';
						break;
					default:
						if ( /物質$/.test(res[0][j]) ){
							t[t.length]='<td  style="text-align: center;" class="col'+ (j+1) +'" title="'+ res[i][j] +'"><div>'+ res[i][j] + '</div></td>';
						}else{
							t[t.length]='<td class="col'+ (j+1) +'" title="'+ res[i][j] +'"><div>'+ res[i][j] + '</div></td>';
						}
					}
				}
			}
			t[t.length]="</tr>";
			if (i==0){ t[t.length]="</thead><tbody>"; }
		}
		t[t.length] = "</tbody></table>";
		$("#result").html(t.join(""));
		
		//テーブルソーター設定
		$("#result table th").click(function(){
			$(this).children().hide().fadeIn();
		});
		$("#result table").tablesorter();
		
		//ダブルクリック設定(登録アプリで開く)
		$("#result td").dblclick(function(){
			var iePath = Shell.RegRead("HKEY_LOCAL_MACHINE\\SOFTWARE\\Classes\\Applications\\iexplore.exe\\shell\\open\\command\\").split('"');
			var app = setting.txtAppPath;
			if (app == ""){ app = iePath[1]; }
			Shell.Run('"'+ app +'" "'+ basePath +"files\\"+ $(this).parent().children(":first").text() +'.xml"');
		});
		//右クリメニュー
		$("#result td").contextMenu('conText', {
			onContextMenu: function(e) {
				$("#result tr.current").removeClass("current");
				$(e.target).parents("tr").addClass("current");
				return true;
			},
			menuStyle: {width: "120px", background: "#eee"},
			itemStyle: {padding: "3px 0 3px 5px", border: "1px solid #eee"},
			bindings: {
				'openApp': function(t) {		//登録アプリで開く
					$(t).dblclick();
				},
				'open': function(t) {			//関連付けで開く
					try {
						Shell.Run('"'+ basePath +"files\\"+ $(t).parent().children(":first").text() +'.xml"');
					}catch(e){
						alert("xmlに関連付けられたアプリケーションがありません");
					}
				},
				'editRemarks': function(t) {	//追記部の編集
					$("#editNo").text( $(t).parent().children(":first").text() );
					$("#dlgEdit").dialog("open");
				},
				'delete': function(t) {		//データ削除
					$(t).parents("tr").addClass("current");
					if ( !confirm("選択行のデータを削除しますか？") ) { $(t).parents("tr").removeClass("current"); return false; }
					var id = $(t).parent().children(":first").text();
					var res = JetMDB.Execute("DELETE * FROM TBL_DESCRIPT WHERE ID = "+ (id-0) +";");
					if ( res ){
						FSO.DeleteFile(basePath + "files\\" + id +".xml");
						createResultTable(lastSearchSQL);
					}else{
						alert(res);
					}
				},
				'fileOutput': function(t) {	//ファイルの出力
					var fileID = $(t).parent().children(":first").text();
					for (;;) {
						var savePath = getFolder("保存先フォルダを選択してください");
						if ( savePath==false ) { return; }
						savePath += "\\AIS_"+ fileID +".xml";
						if ( !FSO.FileExists(savePath) ){ break; }
						if ( confirm("ファイル '"+ FSO.GetFileName(savePath) +"' は既に存在します。既存のファイルを置き換えますか?") ){ break; }
					}
					FSO.CopyFile( basePath +"files\\"+ fileID +".xml", savePath );
				}
			}
		});
	}
}