﻿//=================================================================================================================================
//※※※JET ADODBクラス※※※
//=================================================================================================================================

//***DataTypeEnum***
var adEmpty = 0;
var adSmallInt = 2;
var adInteger = 3;
var adSingle = 4;
var adDouble = 5;
var adCurrency = 6;
var adDate = 7;
var adBSTR = 8;
var adIDispatch = 9;
var adError = 10;
var adBoolean = 11;
var adVariant = 12;
var adIUnknown = 13;
var adDecimal = 14;
var adTinyInt = 16;
var adUnsignedTinyInt = 17;
var adUnsignedSmallInt = 18;
var adUnsignedInt = 19;
var adBigInt = 20;
var adUnsignedBigInt = 21;
var adFileTime = 64;
var adGUID = 72;
var adBinary = 128;
var adChar = 129;
var adWChar = 130;
var adNumeric = 131;
var adUserDefined = 132;
var adDBDate = 133;
var adDBTime = 134;
var adDBTimeStamp = 135;
var adChapter = 136;
var adPropVariant = 138;
var adVarNumeric = 139;
var adVarChar = 200;
var adLongVarChar = 201;
var adVarWChar = 202;
var adLongVarWChar = 203;
var adVarBinary = 204;
var adLongVarBinary = 205;

//***CursorTypeEnum***
var adOpenUnspecified = -1;
var adOpenForwardOnly = 0;
var adOpenKeyset = 1;
var adOpenDynamic = 2;
var adOpenStatic = 3;

//***LockTypeEnum***
var adLockUnspecified = -1;
var adLockReadOnly = 1;
var adLockPessimistic = 2;
var adLockOptimistic = 3;
var adLockBatchOptimistic = 4;

var adPersistXML = 1

var clsJetMDB = function(){
	this.UDL = "";
	this.ConnectionString = "";
	this.MdbAddress = "";
	this.SQL = new Array();
	this.DbCon = new ActiveXObject("ADODB.Connection");
	this.DbRes = new ActiveXObject("ADODB.Recordset");
}

//-----------------------------------------------------------
//SQLプロパティ set / get / clear
//-----------------------------------------------------------
clsJetMDB.prototype.setSQL = function(strSQL){
	this.SQL.push(strSQL);
}
clsJetMDB.prototype.getSQL = function(){
	return this.SQL;
}
clsJetMDB.prototype.clearSQL = function(){
	this.SQL.length = 0;
}
//-----------------------------------------------------------
//UDLプロパティ set / get
//-----------------------------------------------------------
clsJetMDB.prototype.setUDL = function(strUDL){
	this.UDL = strUDL;
	var TxtStrm = FSO.OpenTextFile(this.UDL, ForReading, false, TristateTrue);
	this.MdbAddress = String(TxtStrm.ReadAll());
	TxtStrm.Close();
	this.MdbAddress = String(this.MdbAddress.match(/Data Source=.*;/,""));
	this.MdbAddress = String(this.MdbAddress.replace(/Data Source=|\;/g,""));

	this.setConnectionString("FILE NAME=" + strUDL + ";");
}
clsJetMDB.prototype.getUDL = function(){
	return this.UDL;
}
//------------------------------------------------------------
//ConnnectionStringプロパティ set / get
//------------------------------------------------------------
clsJetMDB.prototype.setConnectionString = function(strConStr){
	this.ConnectionStr = strConStr;
	this.MdbAddress = String(strConStr.match(/Data Source=.*\;/)).replace(/Data Source=|;.*$/g,"");
	this.DbCon.Open(strConStr);
}
clsJetMDB.prototype.getConnectionString = function(){
	return this.ConnectionStr;
}
//------------------------------------------------------------
//MdbAddressプロパティget
//------------------------------------------------------------
clsJetMDB.prototype.getMdbAddress = function(){
	return MyMdbAddress;
}
//********************************************************
//コネクションクローズ
//********************************************************
clsJetMDB.prototype.Close = function(){
	//***使用状況の確認***
	this.DbCon.close();
}
//*********************************************************
//Execute 関数
//*********************************************************
clsJetMDB.prototype.Execute = function(sql){
	//引数SQLの設定
	if (sql!=undefined) {
		this.clearSQL()
		this.setSQL(sql);
	}
	this.DbCon.BeginTrans();
	for (i=0; i<this.SQL.length; i++){
		try{
			this.DbCon.Execute(this.SQL[i]);
		}catch(e){
			this.DbCon.RollbackTrans();
			return e.message;
		}
	}
	this.DbCon.CommitTrans();
	return true;
}
//*********************************************************
//レコードセット配列取得関数
//*********************************************************
clsJetMDB.prototype.getRsArr = function(sql){
	var Res = new Array();	//取得配列
	
	//引数SQLの設定
	if (sql!=undefined) {
		this.clearSQL()
		this.setSQL(sql);
	}
	
	this.DbRes.Open(this.SQL[0], this.DbCon, adOpenForwardOnly, adLockReadOnly)
	
	Res[0] = new Array();
	for (j=0; j<this.DbRes.Fields.count; j++){
		Res[0].push(this.DbRes.Fields(j).Name);
	}
	var reg = new RegExp(String.fromCharCode(0), 'gi');
	if (this.DbRes.EOF==false){
		var i = 0;
		do{
			i++
			Res[i] = new Array();
			for (j = 0; j < this.DbRes.Fields.Count; j++){
				if (this.DbRes.Fields(j).Value==null){
					Res[i][j]="";
				}else{
					switch (this.DbRes.Fields(j).Type){
					case adBSTR:
					case adChar:
					case adWChar:
					case adVarChar:
					case adLongVarChar:
					case adVarWChar:
					case adLongVarWChar:
						Res[i][j] = String(this.DbRes.Fields(j).Value).replace(reg, "");
						break;
					case adDate:
						Res[i][j] = dateFormat(this.DbRes.Fields(j).Value);
						break;
					default:
						Res[i][j] = this.DbRes.Fields(j).Value;
						break;
					}
				}
			}
			this.DbRes.MoveNext();
		}while (this.DbRes.EOF==false);
	}
	this.DbRes.Close();
	return Res;
}
//*********************************************************
//レコードセット XML保存関数 ※同名ファイルがあるとエラー
//*********************************************************
clsJetMDB.prototype.saveAsXML = function(fullPath){
	this.DbRes.Open(this.SQL[0], this.DbCon, adOpenForwardOnly, adLockReadOnly)
	try{
		this.DbRes.Save(fullPath, adPersistXML);
		this.DbRes.Close();
		return true;
	}catch(e){
		this.DbRes.Close();
		return e;
	}
}
//********************************************************
//MDB最適化関数
//********************************************************
clsJetMDB.prototype.Compact = function(){
	//***使用状況の確認***
	this.DbCon.close();
	var useFlag = FSO.FileExists(this.MdbAddress.replace(/\.mdb/gi, ".ldb"));
	if (useFlag){this.DbCon.Open(this.ConnectionString); return false;}
	
	//***使用していない場合は最適化実施***
	var strProvider = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=";
	var objJRO = new ActiveXObject("JRO.JetEngine");
	var ParentFolder = FSO.GetFile(this.MdbAddress).ParentFolder;
	var filename = FSO.GetFile(this.MdbAddress).name;
	
	var oldMdb = strProvider + this.MdbAddress;
	var newMdb = strProvider + ParentFolder + "TMP_" + filename;
	try{
		objJRO.CompactDatabase(oldMdb, newMdb);
	}catch(e){
		this.DbCon.Open(this.ConnectionString);
		return e.message;
	}
	FSO.DeleteFile(this.MdbAddress);
	FSO.MoveFile(ParentFolder + "TMP_" + filename, this.MdbAddress);
	this.DbCon.Open(this.ConnectionString);
	return true;
}
function dateFormat(target, onlyDate){
	var dt = new Date(target);
	var yy = dt.getYear();
	var mm = dt.getMonth() + 1;
	var dd = dt.getDate();
	var h = dt.getHours();
	var m = dt.getMinutes();
	var s = dt.getSeconds();
	if (yy < 2000) { yy += 1900; }
	if (mm < 10) { mm = "0" + mm; }
	if (dd < 10) { dd = "0" + dd; }
	if (h < 10) { h = "0" + h; }
	if (m < 10) { m = "0" + m; }
	if (s < 10) { s = "0" + s; }
	if (h + m + s == 0 | onlyDate){
		dt = String(yy + "/" + mm + "/" + dd);
	}else{
		dt = String(yy + "/" + mm + "/" + dd + " " + h + ":" + m + ":" + s);
	}
	return dt;
}
