﻿/*********************************************************************************************************************************
    機能：ダイアログ設定関数
注意事項：無し
*********************************************************************************************************************************/
function setDialog(){
	////######################### 検索ダイアログ #########################
	var criteriaReset = function(){
		$("#criteria")
			.find("input:checked").removeAttr("checked").end()
			.find("input:text").val("").end()
			.find("input:radio:even").attr("checked","checked").end()
			.find("select").each(function(){
				$(this).children(":first").attr("selected","selected");
			});
		$("#chkItemNoE, #chkCommonName").attr("checked", "checked");
		$("#criteria input:checkbox").change();
		$('.dtp[id$="Start"]').val("2006/01/01");
		$('.dtp[id$="End"]').val(dateFormat(new Date(), true));
	}
	
	$("#dlgSearch").dialog({
		autoOpen: false,
		resizable: false,
		modal: true,
		title: "検索条件",
		width: 650,
		buttons: {
			"検索": function(){
				var sql = getSearchSQL();
				if (sql.err) {
					alert("以下の検索条件に誤りがあります\n\n"+ sql.value);
					return false;
				}
				$(this).dialog("close");
				createResultTable(sql.value);
			},
			"リセット": function(){
				criteriaReset();
			},
			"キャンセル": function(){
				$(this).dialog("close");
			}
		}
	});
	//チェックボックス
	$("#criteria input:checkbox").change(function(){
		if( $(this).is(":checked") ){
			$(this)
				.next().css({"color": "#cd0a0a", "font-weight": "bold"})
			.end()
				.siblings(":not(label:first)")
					.removeAttr("disabled")
					.filter("input:text")
						.css("background", "#fff8f8");
		}else{
			$(this)
				.next().css({"color": "black", "font-weight": "normal"})
			.end()
				.siblings(":not(label:first)")
					.attr("disabled","disabled")
					.filter("input:text")
						.css("background", "#fff");
		}
	});
	
	//検索表示リセット
	criteriaReset();
	
	////######################### カラム表示設定ダイアログ #########################
	$("#dlgColumn").dialog({
		autoOpen: false,
		open: function(){
			for (var o in setting.colView){
				if (setting.colView[o]){
					$("#"+ o).attr("checked", "checked").change();
				}else{
					$("#"+ o).removeAttr("checked").change();
				}
			}
		},
		resizable: false,
		modal: true,
		title: "検索結果 追加表示列設定",
		width: 500,
		buttons: {
			"設定": function(){
				$("#dlgColumn input:checkbox").each(function(){
					setting.colView[this.id] = $(this).is("*:checked");
				});
				$(this).dialog("close");
			},
			"キャンセル": function(){
				$(this).dialog("close");
			}
		}
	});
	$("#dlgColumn input:checkbox").change(function(){
		if ($(this).is("*[checked]")){
			$(this).next().css({"font-weight": "bold", "color": "#cc0a0a"});
		}else{
			$(this).next().css({"font-weight": "normal", "color": "#000"});
		}
	});
	
	//######################### オプション機能ダイアログ #########################
	$("#dlgOption").dialog({
		autoOpen: false,
		resizable: false,
		modal: true,
		title: "オプション",
		width: 380,
		open: function(){
			$("#txtAppPath").val(setting.txtAppPath);
			$("#COL1Alias").val(setting.alias[0]);
			$("#COL2Alias").val(setting.alias[1]);
			$("#COL3Alias").val(setting.alias[2]);
			$("#COL4Alias").val(setting.alias[3]);
			$("#COL5Alias").val(setting.alias[4]);
			$("#chkDeleteFile").attr("checked", setting.chkDeleteFile);
			if ( setting.chkAlertMinS=="" ){
				$("#chkAlertMinS").removeAttr("checked");
				$("#AlertMinS").val("").spinner("disable");
			}else{
				$("#chkAlertMinS").attr("checked", "checked");
				$("#AlertMinS").val(setting.chkAlertMinS);
			}
			if ( setting.chkAlertMinI=="" ){
				$("#chkAlertMinI").removeAttr("checked");
				$("#AlertMinI").val("").spinner("disable");
			}else{
				$("#chkAlertMinI").attr("checked", "checked");
				$("#AlertMinI").val(setting.chkAlertMinI);
			}
		},
		close: function(){
			setting.txtAppPath = $("#txtAppPath").val();
			for (var i=0; i<5; i++){
				setting.alias[i] = $("#COL@Alias".replace(/@/, i+1)).val();
			}
			setting.chkDeleteFile = $("#chkDeleteFile").is(":checked");
			for (var i=0; i<2; i++){
				var prefix = "I"
				if (i==1){ prefix = "S" }
				var spinnerValue = $("#AlertMin"+ prefix).spinner("value");
				if ( $("#chkAlertMin"+ prefix).is(":checked") && spinnerValue!==0 && spinnerValue!==null ){
					setting["chkAlertMin"+ prefix] = spinnerValue;
				}else{
					setting["chkAlertMin"+ prefix] = "";
				}
			}
		},
		buttons: {
			"閉じる": function(){
				$(this).dialog("close");
			}
		}
	});
	//登録アプリ設定
	$("#btnSetApp").click(function(){
		var exe = openFileName(null, "実行ファイル (*.exe)|*.exe", "登録するアプリケーションを選択", false);
		if (exe===false) return;
		$("#txtAppPath").val(exe);
	});
	$("#btnClearApp").click(function(){
		$("#txtAppPath").val("");
	});
	//別名設定
	$("#dlgOption input[id*='Alias']").change(function(){
		$(this).val( $(this).val().convert(strHalf + strWebsafe) );
		$(this).val( $.trim($(this).val().substring(0, 6)) );
		var index = this.id.replace(/COL|Alias/g, "");
		if ($(this).val()==""){
			$(".aliasTgt"+ index).text( "追記"+ index );
			setting.alias[index-1] = "";
		}else{
			$(".aliasTgt"+ index).text( $(this).val() );
			setting.alias[index-1] = $(this).val();
		}
		JetMDB.Execute("UPDATE MST_ALIAS SET ALIAS"+ index +" ='"+ (setting.alias[index-1].replace(/'/g, "''")) +"';");
	});
	//その他の設定
	$("#AlertMinS, #AlertMinI")
		.css({border: "none", padding: 1, margin: 0})
		.spinner({ min: 0, max: 9999, step: 10 })
		.change(function(){
			var val = $(this).spinner("value");
			switch (val){
			case null: $(this).val(0); break;
			default: $(this).val(Math.round(val));
			}
		});
	$("#chkAlertMinS, #chkAlertMinI").change(function(){
		var $input = $("#"+ this.id.replace(/^chk/,""));
		if ( $input.spinner("value")==null ) {
			$input.val("");
		}else{
			$input.val(Math.round($input.spinner("value")));
		}
		if ( $input.spinner("value")==0 ) { $input.val("0"); }
		if ($(this).is(":checked")){
			$input.spinner("enable");
		}else{
			$input.spinner("disable");
		}
	});
	//jquery ui ボタン生成
	$("#dlgOption button").button();
	//最適化
	$("#btnOptCompact").click(function(){
		$("#dlgOption").dialog("close");
		$("#result").html('<div class="loading">データベース最適化...</div>');
		setTimeout(function(){
			var res = JetMDB.Compact();
			$("#result").html("");
			lastSearchSQL = "";
			if (res){
				alert("最適化完了しました");
			}else{
				alert("最適化できませんでした");
			}
			lastSearchSQL = "";
		}, 0);
	});
	//全データ出力
	$("#btnOptAllData").click(function(){
		$("#dlgOption").dialog("close");
		$("#hdOutput").attr("disabled", "disabled").children().css("filter","gray");	//Excel出力の無効化
		$("#result").html('<div class="loading">全データ出力中...</div>');
		setTimeout(function(){
			exportExcel({
				"基本情報": "SELECT * FROM V_ALL_BASIC;",
				"型番情報": "SELECT * FROM V_ALL_ITEMNUMBER;",
				"構成情報": "SELECT * FROM V_ALL_COMPOSITION;"
			});
			//完了通知
			$("#result").html("");
			lastSearchSQL = "";
		}, 0);
	});
	//初期化
	$("#btnOptClearDB").click(function(){
		if ( confirm("登録されているすべての\n\n　・AISデータベース\n　・AISファイル\n　・ユーザー設定\n\nが消去されます\n\n実行していいですか？") ){
			$("#dlgOption").dialog("close");
			$("#result").html('<div class="loading">全データ消去中...</div>');
			setTimeout(function(){
				JetMDB.clearSQL();
				JetMDB.setSQL("DELETE * FROM TBL_DESCRIPT;");
				JetMDB.setSQL("DELETE * FROM MST_OTHER_SETTINGS;");
				JetMDB.setSQL("UPDATE MST_ALIAS SET ALIAS1='', ALIAS2='', ALIAS3='', ALIAS4='', ALIAS5='';");
				var res = JetMDB.Execute();
				res = JetMDB.Compact();
				FSO.GetFolder(basePath + "files").Delete();
				FSO.CreateFolder(basePath + "files");
				window.location.reload();
				alert("消去が完了しました");
			}, 0);
		}
	});
	
	//######################### エディットダイアログ #########################
	$("#dlgEdit").dialog({
		autoOpen: false,
		resizable: false,
		modal: true,
		title: "ユーザー追記　編集",
		width: 340,
		open: function(e){
			var res = JetMDB.getRsArr("SELECT COL1,COL2,COL3,COL4,COL5 FROM TBL_USERADD WHERE LINK="+ $("#editNo").text() +";");
			for (var i=0; i<res[0].length; i++){
				$("#"+ res[0][i]).val(res[1][i]);
			}
		},
		buttons: {
			"登録": function(){
				var val = {COL1: "", COL2: "", COL3: "", COL4: "", COL5: ""};
				for (var p in val){
					val[p] = $("#"+ p).val().convert(strHalf + strWebsafe).substring(0, 254).replace(/'/g, "''").replace(/\t|\n|\r/g, " ");
				}
				var res = JetMDB.Execute(
					"UPDATE TBL_USERADD\n"+
					"SET COL1='"+ val.COL1 +"', COL2='"+ val.COL2 +"', COL3='"+ val.COL3 +"', COL4='"+ val.COL4 +"', COL5='"+ val.COL5 +"' \n"+
					"WHERE LINK="+ ( $("#editNo").text()-0 ) +";"
				);
				$(this).dialog("close");
				createResultTable(lastSearchSQL);
			},
			"キャンセル": function(){
				$(this).dialog("close");
			}
		}
	});
}